
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>IO流详细 / iVAN</title>

    <meta name="description" content="IO流详细 ﻿﻿ API中IO流的结构图 IO(intput output)流 特点:读写之间没有直接联系,读入数组,从数组写入硬盘 IO流用来处理设备之间的数据传输 Java对数据的操作是通过流的方式 Java用于操作流的对象都在IO包中 流按操作数据分两种:字节流(处理图片等)和字符流(早期只有字节流,字节流能处理所有文件,但是文本文件是很常见的,为了方便所以弄了字符流,内部融合了编码表) 流按流向分为:输入流,输出流(针对内存) IO流常用的基类(大量运用了装饰者模式) 字节流的抽象类     Inp">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">IO流详细</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>﻿﻿</p>
<h1>API中IO流的结构图</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTIyMjM1NDI0Mzc=.jpg"></p>
<h1>IO（intput output）流</h1>
<p>特点：读写之间没有直接联系，读入数组，从数组写入硬盘</p>
<p>IO流用来处理设备之间的数据传输</p>
<p>Java对数据的操作是通过流的方式</p>
<p>Java用于操作流的对象都在IO包中</p>
<p>流按操作数据分两种：字节流（处理图片等）和字符流（早期只有字节流，字节流能处理所有文件，但是文本文件是很常见的，为了方便所以弄了字符流,内部融合了编码表）</p>
<p>流按流向分为：输入流，输出流（针对内存）</p>
<h1>IO流常用的基类(大量运用了装饰者模式)</h1>
<p>字节流的抽象类</p>
<p>    InputStream,OutputStream</p>
<p>字符流的抽象类</p>
<p>    Reader,Writer</p>
<p>有这四个类派生出来的子类名称都是以其父类名作为子类名的后缀。</p>
<h1>Writer类（字符流的输出类）</h1>
<h1>FileWriter</h1>
<p>FileWriter fw = new FileWriter("demo.txt");//如果demo.txt里面有东西，里面的东西会被清空</p>
<p>fw.write("sdgdfh");//这里是将字符串写入流中，也就是内存中，由于它里面有缓冲，想要把数据写入目标文件的话，要调用fluesh()方法</p>
<pre>FileWriter fw = new FileWriter("C:\\Users\\JSON\\Desktop\\a.txt");
//		fw.flush();//在写入前调用达不到效果，要在写入字符串后调用
		fw.write("aaaaa");
		fw.flush();//刷新缓冲区，将缓冲区的内容刷到目的地中
		fw.close();//它的效果和flush差不多，关前会刷新缓冲区，关了流再写东西，已经关闭了怎么东西呢？所以报错</pre>
<p>在一个已有内容的文件末尾续写其它内容。</p>
<p>   <a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">FileWriter</a>(<a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a> fileName, boolean append) <br />
          根据给定的文件名以及指示是否附加写入数据的 boolean 值来构造 FileWriter 对象。更详细的看帮助文档。</p>
<pre>package com.itheima.shipin1;

import java.io.FileWriter;

/**
 * 在一个有内容的txt文件中，继续写入其他东西
 *
 * @author Terry
 * @date 2014-6-10
 *
 */
public class FileWriterTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		// TODO Auto-generated method stub
		FileWriter fw = new FileWriter("C:\\Users\\JSON\\Desktop\\a.txt",true);
		fw.write("bbbbb");//windows的当中，它的回车符是\r\n,其他的可以用\n
		fw.flush();
		fw.close();
	}

}
</pre>
<h1>FileReader类</h1>
<pre>package com.itheima.shipin1;

import java.io.FileReader;
import java.io.FileWriter;

/**
 *
 *
 * @author Terry
 * @date 2014-6-10
 *
 */
public class FileWriterTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		// TODO Auto-generated method stub
		FileReader fr = new FileReader("C:\\Users\\JSON\\Desktop\\a.txt");
		int ch = 0;
		while((ch = fr.read())!=-1){//回来看的时候，如果忘了看帮助文档
			System.out.println((char)ch);
		}
	}

}
</pre>
<p><pre>package com.itheima.shipin1;

import java.io.FileReader;
import java.io.FileWriter;

/**
 *
 * //这方法可以打印文件
 * @author Terry
 * @date 2014-6-10
 *
 */
public class FileWriterTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		// TODO Auto-generated method stub
		FileReader fr = new FileReader("C:\\Users\\JSON\\Desktop\\a.txt");
//		char[] char1 = new char[3];
//		int num = fr.read(char1);//将内容读到char1里面，如果开始读了3个，后面再读2个，最后读的这2个覆盖数组里的前2两个，数组中的第三个元素还是原来第一次读的时候的那个
//		System.out.println(num + "::"+new String(char1));
//		int num1 = fr.read(char1);
//		System.out.println(num1 + "::"+new String(char1));
		int numb = -1;
//		char[] buf = new char[2];//通常情况下这里定的是1024的整数倍，1024是一字节
		char[] buf = new char[1024];
		while ((numb = fr.read(buf))!=-1) {//此时fr.read(buf)返回的是读的个数

			System.out.println(new String(buf,0,numb));

		}
	}

}
</pre>
<h1>File类（操作文件的类）(重要)</h1>
<h2>常用方法</h2>
<p> 创建：</p>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">createNewFile</a>()</code><br />
          当且仅当不存在具有此抽象路径名指定名称的文件时，不可分地创建一个新的空文件。（文件如果存在则不创建，返回false）输出流创建的文件会覆盖原文件</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">mkdir</a>()</code><br />
          创建此抽象路径名指定的目录。（创建文件夹,只能创建一级目录，aaa\\bbb\\ccc是不能创建的）</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">mkdirs</a>()</code><br />
          创建此抽象路径名指定的目录，包括所有必需但不存在的父目录。(创建多级文件夹)</td>
</tr>
</tbody>
</table>
<p> </p>
<p>删除：</p>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">delete</a>()</code><br />
          删除此抽象路径名表示的文件或目录。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<br /><code>void</code></p>
</td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">deleteOnExit</a>()</code><br />
          在虚拟机终止时，请求删除此抽象路径名表示的文件或目录。（对文件做一系列动作时，最后要删除，但是突然出现异常，用上面的方法就删不掉，代码走不到他那就异常退出了，在程序退出时删除指定文件）</td>
</tr>
</tbody>
</table>
<p>删除文件夹中的所有东西，包括自身</p>
<pre>&lt;pre class="java" name="code"&gt;package com.itheima.shipin1;

import java.io.File;

public class DeleteFile {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File file = new File("F:\\新建文件夹");
		remove(file);
	}

	public static void remove(File file){
		if(file.exists()){//不加if语句会报空指针异常
			for (File file1 : file.listFiles()) {
				if(file1.isDirectory())   // if(!file1.isHidden()&amp;&amp;file1.isDirectory())//这里以后最好都这样写，养成好//习惯
					remove(file1);
//					file1.delete();原本我是想在这用这方法删除的，但是看了视频后，还是在下面删除的好，可以少删除几次文件
				else
					System.out.println("delete:"+file1.delete());
			}
			System.out.println("delete:"+file.delete());
		}
	}
}
</pre>

<pre></pre>
<p>判断：</p>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">exists</a>()</code>          测试此抽象路径名表示的文件或目录是否存在。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">isDirectory</a>()</code>          测试此抽象路径名表示的文件是否是一个目录。（先判断文件是否存在）</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">isFile</a>()</code>          测试此抽象路径名表示的文件是否是一个标准文件。（先判断文件是否存在）</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">isHidden</a>()</code>          测试此抽象路径名指定的文件是否是一个隐藏文件。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">isAbsolute</a>()</code>          测试此抽象路径名是否为绝对路径名。（文件不存在也行）</td>
</tr>
</tbody>
</table>
<p>获取信息：</p>
<table>
<tbody>
<tr>
<td><code> <a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a></code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">getName</a>()</code>          返回由此抽象路径名表示的文件或目录的名称。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code> <a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a></code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">getPath</a>()</code>          将此抽象路径名转换为一个路径名字符串。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a></code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">getParent</a>()</code>          返回此抽象路径名父目录的路径名字符串；如果此路径名没有指定父目录，则返回<code>null</code>。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a></code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">getAbsolutePath</a>()</code>          返回此抽象路径名的绝对路径名字符串。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code> long</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">lastModified</a>()</code>          返回此抽象路径名表示的文件最后一次被修改的时间。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code> long</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">length</a>()</code>          返回由此抽象路径名表示的文件的长度。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>boolean</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">renameTo</a>(<a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">File</a> dest)</code>          重新命名此抽象路径名表示的文件。</td>
</tr>
</tbody>
</table>
<p>File file1 = new File("C:\\haha.java"):</p>
<p>File file2 = new File("D:\\hehe.java");</p>
<p>file1.renameTo(file2);</p>
<p>执行，原理是，把file的文件copy，然后删除，在把里面的内容写给file2，创建file2</p>
<h2>重要的方法</h2>
<table>
<tbody>
<tr>
<td><code>static <a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">File</a>[]</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">listRoots</a>()</code>          列出可用的文件系统根。</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a>[]</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">list</a>()</code>          返回一个字符串数组，这些字符串指定此抽象路径名表示的目录中的文件和目录。(隐藏文件也打印)</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">String</a>[]</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">list</a>(<a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">FilenameFilter</a> filter)</code>          返回一个字符串数组，这些字符串指定此抽象路径名表示的目录中满足指定过滤器的文件和目录。</td>
</tr>
</tbody>
</table>
<p> </p>
<pre>package com.itheima.shipin1;

import java.io.File;
import java.io.FilenameFilter;

/**
 * 实现文件筛选功能
 *
 * @author Terry
 * @date 2014-6-10
 *
 */
public class FileWriterTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		// TODO Auto-generated method stub
		File file = new File("C:\\Users\\JSON\\Desktop\\学习");//目录文件
		String [] a = file.list(new FilenameFilter() {

			@Override
			public boolean accept(File dir, String name) {
				// TODO Auto-generated method stub
//				/**
//				 * 筛选条件自定义
//				 */
//				String [] a = name.split("\\.");
//				if(a[a.length-1].equals("java")){
//					return true;
//				}
//				return false;
				return name.endsWith(".java");
			}
		});

		/**
		 * 打印结果
		 */
		for (String string : a) {
			System.out.println(string);
		}

	}

}
</pre>
<table>
<tbody>
<tr>
<td><code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">File</a>[]</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">listFiles</a>(<a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">FileFilter</a> filter)</code><br />
          返回抽象路径名数组，这些路径名表示此抽象路径名表示的目录中满足指定过滤器的文件和目录。</td>
</tr>
</tbody>
</table>
<pre>&lt;pre class="java" name="code"&gt;package com.itheima.shipin1;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;

public class DeleteFile {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			go1();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public static void go1() throws Exception{
		File from = new File("F:\\海伦音标");
		File to = new File("F:\\test.txt");
		FileWriter fileWriter = new FileWriter(to);
		BufferedWriter bw = new BufferedWriter(fileWriter);
		fileList(from,to,bw);
	}

	/**
	 * 获取指定目录下的java文件的绝对路径，并存储到一个文本文件中。
	 * @param from:指定的文件
	 * @param to:将目录写到哪
	 * @throws Exception
	 */
	public static void fileList(File from,File to,BufferedWriter bw) throws Exception{
		File[] files1 =  from.listFiles();
		for (File file : files1) {
			if(!file.isHidden()&amp;&amp;file.isDirectory())
				fileList(file, to, bw);
			else
				if(file.getName().endsWith(".java")){
					bw.write(file.getAbsolutePath()+"\r\n");
//					bw.write(file.getAbsolutePath());
//					bw.newLine();
//					bw.flush();
				}
		}
		bw.close();//不关闭流，to文件中没有内容，因为写入的是内存，也可以调用bw.flush();，但要在close前面

	}</pre>
<p>}
<pre></pre>
<h1>Properties类（还能操作硬盘上的键值对信息）</h1>
<p>Properties是hashtable的子类，也就是说它具备map集合的特点。而且它里面存储的键值对都是字符串。是集合中和IO技术相结合的集合容器。</p>
<p>该对象的特点：可以用于键值对形式的配置文件。</p>
<p>XML:存储软件的一些基本配置信息</p>
<pre>&lt;pre class="java" name="code"&gt;package com.itheima.shipin1;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.util.Properties;
import java.util.Set;

public class DeleteFile {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		go2();
	}

	public static void go2(){
		Properties prop = new Properties();
		prop.setProperty("zhangsan", "30");
		prop.setProperty("lisi", "39");
//		System.out.println(prop);
		String value = prop.getProperty("lisi");
		System.out.println(value);
		Set&lt;String&gt; set = prop.stringPropertyNames();
		for (String s : set) {
			System.out.println(prop.getProperty(s));
		}
	}
}
</pre>
<pre></pre>
<table>
<tbody>
<tr>
<td><code> void</code></td>
<td>
<code><a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">load</a>(<a href="http://write.blog.csdn.net/postedit/29575983" rel="external nofollow noreferrer">InputStream</a> inStream)</code>          从输入流中读取属性列表（键和元素对）。</td>
</tr>
</tbody>
</table>
<h2>操作一个已存在的.txt中的键值对内容</h2>
<p>     </p>
<pre>package com.itheima.shipin1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.Writer;
import java.util.Properties;
import java.util.Set;

public class DeleteFile {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			go2();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void go2() throws Exception{
		Properties pt = new Properties();
		BufferedReader br = new BufferedReader(new FileReader("F:\\java\\BianChengRuanJian\\myeclipseworkspace\\LearningIOStream\\src\\com\\itheima\\shipin1\\ini.txt"));
		pt.load(br);//加载
		System.out.println(pt.get("zhangsan4"));
		pt.setProperty("zhangsan4", "11111");//修改
		System.out.println(pt.get("zhangsan4"));
		pt.load(br);//加载，为的是看看ini.txt的内容会被改不
		System.out.println(pt.get("zhangsan4"));//看到的结果是被更改了，但是ini.txt文件内的内容却没更改，要用save()方法但过时了
		Writer writer = new BufferedWriter(new FileWriter("F:\\java\\BianChengRuanJian\\myeclipseworkspace\\LearningIOStream\\src\\com\\itheima\\shipin1\\ini.txt"));
		//把properties类中的"zhangsan4"写入
		pt.store(writer, "zhangsan4");//这时候，ini.txt文件的内容被改了
		pt.setProperty("zhangsan3", "2222222");
		//指定的文件中，后面的string是注释信息，可加可不加
		pt.store(writer, "");
		pt.load(br);
		for (String string : pt.stringPropertyNames()) {
			System.out.println(string+"----"+pt.getProperty(string));
		}
	}
}	</pre>
<h2>小练习</h2>
<p>1、用于记录应用程序运行次数。如果使用次数已到，那么给出注册提示</p>
<pre>&lt;pre class="java" name="code"&gt;Properties pp = new Properties();
		FileInputStream fis = new FileInputStream("F:\\java\\BianChengRuanJian\\myeclipseworkspace\\LearningIOStream\\src\\com\\itheima\\shipin1\\ini.txt");
		pp.load(fis);
		String frequencyOfUse1 = pp.getProperty("FrequencyOfUse");//作用是一样的，得到的字符以;结尾
//		String frequencyOfUse2 = (String) pp.get("FrequencyOfUse");//作用是一样的
		Integer temp = Integer.parseInt(frequencyOfUse1);
		if(temp&gt;=3){//用3次
			System.out.println("试用期已过，请注册，（请给钱，亲）");
		}else{
			System.out.println(frequencyOfUse1);
			temp ++;
			pp.setProperty("FrequencyOfUse", temp.toString());
			FileWriter fw = new FileWriter("F:\\java\\BianChengRuanJian\\myeclipseworkspace\\LearningIOStream\\src\\com\\itheima\\shipin1\\ini.txt");
			pp.store(fw, "");
			fw.close();
		}</pre>

<pre></pre>
<h2>递归方法要注意的地方</h2>
<p>1、循环条件</p>
<p>2、要注意递归的次数，尽量避免内存溢出</p>
<h3>什么时候用递归：</h3>
<p>递归与循环是两种不同的解决问题的典型思路。 递归算法： 优点：代码简洁、清晰，并且容易验证正确性。（如果你真的理解了算法的话，否则你更晕） 缺点：它的运行需要较多次数的函数调用，如果调用层数比较深，需要增加额外的堆栈处理，比如参数传递需要压栈等操作，会对执行效率有一定影响。但是，对于某些问题，如果不使用递归，那将是极端难看的代码。循环算法：  优点：速度快，结构简单。缺点：并不能解决所有的问题。有的问题适合使用递归而不是循环。如果使用循环并不困难的话，最好使用循环。递归算法 和循环算法总结  1.   一般递归调用可以处理的算法，也通过循环去解决常需要额外的低效处理 。2.   现在的编译器在优化后，对于多次调用的函数处理会有非常好的效率优化，效率未必低于循环。</p>
<h1>IO包中的其他类</h1>
<h1>PrintWrite（字符打印流,作用很大）（Web开发的时候，最常用）</h1>
<p> 该流提供了打印方法，可以原样的打印各种数据类型。print()方法。</p>
<p> 构造方法接收参数：比PrintStream多了4的构造参数方法</p>
<p>1、file对象。File</p>
<p>2、字符串路径。String</p>
<p>3、字节输出流。OutputStream</p>
<p>4、字符输出流。Writer</p>
<h1>PrintStream（字节打印流）</h1>
<h1>SequenceInputStream（序列流）读取多个流对象成一个流对象</h1>
<p>合并文件</p>
<pre>/**
	 * 合并文件
	 * @throws Exception
	 */
	public static void go5() throws Exception{
		FileReader os1 = new FileReader("C:\\Users\\JSON\\Desktop\\1.txt");
		FileReader os2 = new FileReader("C:\\Users\\JSON\\Desktop\\2.txt");
		FileReader os3 = new FileReader("C:\\Users\\JSON\\Desktop\\3.txt");
		FileReader os4 = new FileReader("C:\\Users\\JSON\\Desktop\\4.txt");
		List&lt;FileReader&gt; list = new ArrayList&lt;FileReader&gt;();
		list.add(os1);
		list.add(os2);
		list.add(os3);
		list.add(os4);
		byte[] temp = new byte[1024];
		String next = null;
		FileWriter fos = new FileWriter("C:\\Users\\JSON\\Desktop\\5.txt");
		BufferedWriter bw = new BufferedWriter(fos);
		for (FileReader b : list) {
			BufferedReader br = new BufferedReader(b);
			while ((next = br.readLine())!=null) {
				bw.write(next);
				bw.newLine();
			}
			br.close();
		}
		bw.close();
		fos.close();
	}

	/**
	 * 合并文件
	 * @throws Exception
	 */
	public static void go4() throws Exception{
		Vector&lt;InputStream&gt; vt = new Vector&lt;InputStream&gt;();
		vt.add(new FileInputStream("C:\\Users\\JSON\\Desktop\\1.txt"));
		vt.add(new FileInputStream("C:\\Users\\JSON\\Desktop\\2.txt"));
		vt.add(new FileInputStream("C:\\Users\\JSON\\Desktop\\3.txt"));
		vt.add(new FileInputStream("C:\\Users\\JSON\\Desktop\\4.txt"));
		SequenceInputStream ss = new SequenceInputStream(vt.elements());
		byte[] temp = new byte[1024];
		int next = -1;
		FileOutputStream fos = new FileOutputStream("C:\\Users\\JSON\\Desktop\\5.txt");
		BufferedOutputStream bw = new BufferedOutputStream(fos);
		while ((next = ss.read(temp))!=-1) {
			bw.write(temp,0,temp.length);
		}
		bw.close();
		fos.close();
		ss.close();
	}</pre>
<p>把一个大的文件切割成几个小的文件，然后在把这几个小的文件给合并成原文件。</p>
<pre>package com.itheima.shipin1;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

public class MergersAndCutting {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		List list = new ArrayList();
		list.add("C:\\Users\\JSON\\Desktop\\cutting1.txt");
		list.add("C:\\Users\\JSON\\Desktop\\cutting2.txt");
		list.add("C:\\Users\\JSON\\Desktop\\cutting3.txt");
		try {
			cutting();
			merger(list);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 合并文件
	 */
	public static void merger(List&lt;String&gt; paths) throws Exception{
		InputStream is = null;
		OutputStream os = new FileOutputStream("C:\\Users\\JSON\\Desktop\\merger.flv");
		int len = -1;
		byte[] b = new byte[1024];
		for (String path : paths) {
			is = new FileInputStream(path);
			while ((len = is.read(b))!=-1) {
				os.write(b);
			}
			is.close();
		}
		os.close();
	}

	public static void cutting() throws Exception{
		InputStream is = new FileInputStream("F:\\海伦音标\\1.flv");
		OutputStream os = null;
		int len = 0;
		byte[] temp = new byte[1024*1024*2];
		int count = 1;
		while ((len = is.read(temp))!=-1) {
			os = new FileOutputStream("C:\\Users\\JSON\\Desktop\\cutting"+count+++".txt");
			os.write(temp);
			os.close();
		}
		is.close();
	}
}
</pre>
<h1>ObjectInputStream和ObjectOutputStream（序列化和反序列化）使用频率不高，但有用到</h1>
<p>对象存在堆内存，变量存在栈内存</p>
<p>要持久化存储的对象必须实现Serializable（序列化）接口</p>
<p>静态属性不能被序列化</p>
<p>transient  修饰的非静态成员变量，也不会被序列化。</p>
<p>ObjectOutputStream写的文件，只有ObjectInputStream才能读出来，我用自定义类加载器加载过，序列化多个文件，read一次返回第一个对象，再read一次返回第二个对象</p>
<pre>package com.itheima.shipin1;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

public class ObjectStream implements Serializable{
	People p = new People("zf",27);
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			serialization();//当把这里注释，然后改动People对象，运行unSerialization()时会报类有问题的异常。序列号不一样，序列号的//值来源于成员的变量
			unSerialization();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 把对象持久化存储
	 */
	public static void serialization() throws Exception{
		FileOutputStream fos = new FileOutputStream("C:\\Users\\Public\\Desktop\\test.obj");//要存储的目标文件
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		ObjectStream os = new ObjectStream();
		oos.writeObject(os.p);
	}

	/**
	 * 把对象反持久化
	 */
	public static void unSerialization() throws Exception{
		FileInputStream fos = new FileInputStream("C:\\Users\\Public\\Desktop\\test.obj");//要存储的目标文件
		ObjectInputStream oos = new ObjectInputStream(fos);

		People os = (People)oos.readObject();
		System.out.println(os.getClass());
		System.out.println(os.name+"---"+os.age);
	}

	class People implements Serializable{//内部类很麻烦，连改个外部类就会发生类有问题的异常
		String name;
		int age;

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public int getAge() {
			return age;
		}

		public void setAge(int age) {
			this.age = age;
		}

		public People(String name,int age){
			this.name = name;
			this.age = age;
		}

	}
}
</pre>
<h1>管道流PipedInputStream和PipedOutputStream与多线程相关</h1>
<p>管道输入流类</p>
<pre>package com.itheima.pipedInputstream;

import java.io.PipedInputStream;

/**
 * 管道流IO
 *
 * @author Terry
 * @date 2014-6-14
 *
 */
public class PipedInputStreamThread implements Runnable{
	private PipedInputStream pipedInputStream ;

	public PipedInputStreamThread(PipedInputStream pipedInputStream){
		this.pipedInputStream = pipedInputStream;
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		try {
			byte[] a = new byte[1024];
			int len = 0;
//			while ((len = pipedInputStream.read(a))!= -1) {//这些程序会报错,返回的是读的字符个数
//				System.out.println(len);
//				String temp = new String(a);
//				System.out.println(temp);
//			}
			System.out.println("准备读数据");
			len = pipedInputStream.read(a);
			String temp = new String(a);
			System.out.println(temp);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}

	}

}
</pre>
<p>管道输出流类</p>
<pre>package com.itheima.pipedInputstream;

import java.io.PipedOutputStream;

/**
 * 管道流IO
 *
 * @author Terry
 * @date 2014-6-14
 *
 */
public class PipedOutputStreamThread implements Runnable{
	private PipedOutputStream pipedOutputStream ;

	public PipedOutputStreamThread(PipedOutputStream pipedOutputStream){
		this.pipedOutputStream = pipedOutputStream;
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		try {
			Thread.sleep(5000);
			System.out.println("5秒后开始写！");
			Thread.sleep(5000);
			pipedOutputStream.write("hahahahahaha".getBytes());
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}

}
</pre>
<p>Main类</p>
<pre>package com.itheima.pipedInputstream;

import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;

public class Main {
	public static void main(String[] a){
		PipedInputStream pipedInputStream = new PipedInputStream();
		PipedOutputStream pipedOutputStream = new PipedOutputStream();
		try {

			pipedInputStream.connect(pipedOutputStream);

			new Thread(new PipedInputStreamThread(pipedInputStream)).start();

			new Thread(new PipedOutputStreamThread(pipedOutputStream)).start();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
</pre>
<h1>RandomAccessFile(随机访问文件类，结尾没有父类后缀，自成一派)</h1>
<p>特点：1、它不算是IO体系中的子类，直接继承Object.</p>
<p>           2、它又在IO包中，因为它具备读和写功能。</p>
<p>           3、内部封装数组，通过指针操作数组，可以用getFilePointer获取指针位置，可以用seek改变指针位置。</p>
<p>           4、它完成读写的原理是内部封装了字节输入流和输出流。</p>
<p>           5、看构造函数得知他只能操作文件，并且带模式访问。</p>
<h1>DataInputStream与DataOutputStream（用的频率很高，操作基本数据类型）</h1>
<pre>package com.itheima.datainputstream;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

public class DataInputStreamDemo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
//			dataOutputStreamWrite();
//			dataInputStreamWrite();
//			dataOutputStreamWriteUTF();
			outputStreamWriter();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 有编码器
	 */
	public static void outputStreamWriter()throws Exception{
		OutputStreamWriter outputStreamWriter = new OutputStreamWriter(new FileOutputStream("gbk.txt"),"gbk");
		outputStreamWriter.write("你好");
		OutputStreamWriter outputStreamWriter1 = new OutputStreamWriter(new FileOutputStream("utf.txt"),"utf-8");
		outputStreamWriter1.write("你好");
		outputStreamWriter.close();
		outputStreamWriter1.close();
	}

	public static void dataOutputStreamWriteUTF()throws Exception{
		DataOutputStream dataOutputStream = new DataOutputStream(new FileOutputStream("WriteUTF.txt"));
		dataOutputStream.writeUTF("张帆张帆");
		dataOutputStream.close();
	}
	/**
	 * 用DataOutputStream写文件
	 */
	public static void dataOutputStreamWrite() throws Exception{
		DataOutputStream dataOutputStream = new DataOutputStream(new FileOutputStream("dataOutputStream.txt"));
		dataOutputStream.writeInt(2354);
		dataOutputStream.writeDouble(23.4);
		dataOutputStream.writeUTF("张帆");//特殊方法，用这方法写的，也得用这方法读
		dataOutputStream.writeBytes("a");
		dataOutputStream.close();
	}

	/**
	 * 用DataOutputStream写文件
	 */
	public static void dataInputStreamWrite() throws Exception{
		DataInputStream dataInputStream = new DataInputStream(new FileInputStream("dataOutputStream.txt"));
		//读的顺序必须和写的顺序一样，要不数据错误
		int a = dataInputStream.readInt();
		double b = dataInputStream.readDouble();
		String c = dataInputStream.readUTF();
		byte d = dataInputStream.readByte();
		System.out.println(a+"---"+b+"---"+c+"---"+d);
		dataInputStream.close();
	}
}
</pre>
<h1>ByteArrayInputStream和ByteArrayOutputStream（也很有用，类加载器用到过，操作字节数组）</h1>
<p>这两个类没有用到系统资源，所以不用关闭，就算关闭了，它们还能使用</p>
<p>源设备：</p>
<p>        键盘：System.in，硬盘：FileStream，内存：ArrayStream。</p>
<p>目的设备：</p>
<p>        控制台：System.out，硬盘：FileStream，内存：ArrayStream。</p>
<p>ByteArrayOutputStream的好处是可以将字节读进去，然后是动态的，配合类加载器用</p>
<pre>package com.itheima.bytearrayinputstream;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class ByteArrayInputStreamTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		//数据源
		ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream("hahasdhug".getBytes());
		//数据目的
		ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
		System.out.println(byteArrayOutputStream.size());
		int len = 0;
		while((len = byteArrayInputStream.read())!=-1){//read()方法，返回的是读到的字节，用int显示的
			byteArrayOutputStream.write(len);
		}

		System.out.println(byteArrayOutputStream.toString());

		FileInputStream fileInputStream = null;
		try {
			fileInputStream = new FileInputStream("test.obj");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int temp = 0;
		try {
			while((temp = fileInputStream.read())!=-1){
				byteArrayOutputStream.write(temp);
			}
			fileInputStream.close();
			System.out.println(byteArrayOutputStream.toString());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
</pre>
<h1>CharArrayReader和CharArrayWriter(和ByteArrayInputStream用法一样)</h1>
<h1>StringReader和StringWriter(和ByteArrayInputStream用法一样)</h1>
<h1>InputStreamReader和OutputStreamWriter（字节和字符之间的转换用）</h1>
<h1>字符编码</h1>
<h2>编码：字符变字节</h2>
<h2>解码：字节变字符</h2>
<p>﻿﻿</p>
<p>﻿﻿</p>
<p>﻿﻿</p>
<p>﻿﻿</p>
<p>﻿﻿</p>
<p>﻿﻿</p>
<p>﻿﻿</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 12:04:31</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/new/" title="new">new</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/json/" title="json">json</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/java%e6%a0%b8%e5%bf%83%e6%8a%80%e6%9c%af/" title="Java核心技术">Java核心技术</a>, <a href="https://www.iamivan.net/tag/exception/" title="exception">exception</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/javase/" title="javase">javase</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>IO流详细的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlArnp.html" rel="bookmark">PHP Streams&lpar;流&rpar;详细介绍及使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了PHP Streams(流)详细介绍及使用,PHP Streams是内置核心操作,可能一般的开发者很少用,它用于统一文件.网络.数据压缩等类文件操作方式,并为这些类文件操作提供一组通用的函数接口,需要的朋友可以参考下 PHP Streams是内置核心操作,可能一般的开发者很少用,它用于统一文件.网络.数据压缩等类文件操作方式,并为这些类文件操作提供一组通用的函数接口. 一个stream就是一个具有流式行为的资源对象,每个stream对象都有一个包装类.Stream 可以通过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7kAAz.html" rel="bookmark">Java中IO流，输入输出流概述与总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总结的很粗糙,以后时间富裕了好好修改一下. 1:Java语言定义了许多类专门负责各种方式的输入或者输出,这些类都被放在java.io包中.其中, 所有输入流类都是抽象类InputStream(字节输入流),或者抽象类Reader(字符输入流)的子类: 而所有输出流都是抽象类OutputStream(字节输出流)或者Writer(字符输出流)的子类. [首先需要明白的是:流是干什么的???(为了永久性的保存数据)   根据数据流向的不同分为输入流和输出流:   根据处理数据类型的不同分为字符流和字			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNQ5ep.html" rel="bookmark">PHP Streams&lpar;流&rpar;详细介绍及使用&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP Streams是内置核心操作,可能一般的开发者很少用,它用于统一文件.网络.数据压缩等类文件操作方式,并为这些类文件操作提供一组通用的函数接口. 一个stream就是一个具有流式行为的资源对象,每个stream对象都有一个包装类.Stream 可以通过&lt;scheme&gt;://&lt;target&gt;方式来引用.其中&lt;scheme&gt;是包装类的名字,&lt;target&gt;中的内容是由包装类的语法指定,不同的包装类的语法会有所不同. 来看看PHP 默认有哪些内置的包装类:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8jgL3b.html" rel="bookmark">Java 1&period;1的IO流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				到这个时候,大家或许会陷入一种困境之中,怀疑是否存在IO流的另一种设计方案,并可能要求更大的代码量.还有人能提出一种更古怪的设计吗?事实上,Java 1.1对IO流库进行了一些重大的改进.看到Reader和Writer类时,大多数人的第一个印象(就象我一样)就是它们用来替换原来的InputStream和OutputStream类.但实情并非如此.尽管不建议使用原始数据流库的某些功能(如使用它们,会从编译器收到一条警告消息),但原来的数据流依然得到了保留,以便维持向后兼容,而且: (1) 在老式层			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ73nJb.html" rel="bookmark">java的IO流的典型应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尽管库内存在大量IO流类,可通过多种不同的方式组合到一起,但实际上只有几种方式才会经常用到.然而,必须小心在意才能得到正确的组合.下面这个相当长的例子展示了典型IO配置的创建与使用,可在写自己的代码时将其作为一个参考使用.注意每个配置都以一个注释形式的编号起头,并提供了适当的解释信息.   //: IOStreamDemo.java // Typical IO Stream Configurations import java.io.*; import com.bruceeckel.tools.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7kg7M.html" rel="bookmark">java 标准Io流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我想问下,为什么java里面要有标准IO流,有了字节流和字符流,不就可以了吗.为什么啊,我晕. 问题补充:blessed24 写道 解决方案 标准IO指计算机的的输入设备和输出设备,搞这些的吧,为了兼容不同系统,不同物理设备的输入与输出!解决方案二:引用是不是说,只有标准Io实现了跨平台,其他的流都不是跨平台的?标准IO 一般所有的操作系统都是一样的...windows要遵循,linux也一样吧....解决方案三:引用inpublic static final InputStream			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWXBQb.html" rel="bookmark">io流-&period;jsp页面IO流读取文件报错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 .jsp页面IO流读取文件报错 &lt;%@ page language=&quot;&quot;java&quot;&quot; import=&quot;&quot;java.util.*&quot;&quot; pageEncoding=&quot;&quot;gb2312&quot;&quot;%&gt;&lt;%@ page import=&quot;&quot;java.io.*&quot;&quot;%&gt;&lt;%@ page import=&quot;&quot;org.a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXj3D5b.html" rel="bookmark">too many open files-Log4J中Logger如何关闭IO流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Log4J中Logger如何关闭IO流 在项目由于日志需要对日志进行扩展,根据交易号和日期生成logger对象放入队列中,每天会清除之前的日志对象,刚开始没有发现问题,大约到了1个月左右,生产中报了java.net.SocketException:too many open files异常,首先整个系统中除了日志外,只有读取配置文件的两个本地IO操作,其他的是网络IO,其次在早上没有大规模并发请求,除了心跳报文外,其他无请求,综合上述可以将问题定位在日志上.仔细想每天我只是把日志对象从			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8w92b.html" rel="bookmark">io流-IO流输入流问题。。。。。。。。。。。。。。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 IO流输入流问题.............. action类中代码 public class UploadPicAction extends ActionSupport { private String picName; private File pic; private String picFileName; private String picContentType; public String getPicName() { return picName; } public voi			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgABzP.html" rel="bookmark" class="title">如何解决360浏览器上收藏夹不见了的问题</a>
					<div>
						  对于360浏览器,我们很多人都在用它,天天和它打交道.不管是什么,都不可能十全十美的,都是有它的缺点.Win7系统的用户,在使用360浏览器的时候出现了一些问题,即收藏夹不见了,这可如何是好呢?下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWX8jp.html" rel="bookmark" class="title">Python Lesson 1 &colon;About list for if and function</a>
					<div>
						1.1 安装Python3 在Mac或Linux系统使用命令 python3 -V(Uppercase &quot;v&quot;by the way ).如果已经安装,则显示版本,否则提示命令不存在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNJAoM.html" rel="bookmark" class="title">网页上的广告条设计</a>
					<div>
						广告|设计|网页 banner条,是网站用来作为盈利或者是发布一些重要的信息的工具.但是它又不能作为网页的主要内容,因为它的主要目的是吸引人的注意力,让人来购买某种商品,或者是让人注意网站的一些动向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M03Omb.html" rel="bookmark" class="title">数据库字段复用的基本原理与示例</a>
					<div>
						  一.逻辑代数基础: 1,数字用二进制表示,所有可能出现的数只有0和1两个. 2,基本运算只有&quot;与&quot;.&quot;或&quot;.&quot;非&quot;三种. 与运算定义为: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjKGmM.html" rel="bookmark" class="title">亲密接触ASP&period;Net&lpar;16&rpar; Cookie</a>
					<div>
						Cookie Cookie的用法也和ASP中差不多.比如我们建立一个名为aspcn,值为飞刀的cookie HttpCookie cookie = new HttpCookie[&quot;aspcn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYAE9M.html" rel="bookmark" class="title">虚拟机VMWARE中ORACLE License的计算方式</a>
					<div>
						Oracle License的计算有两种方式:按照用户数和CPU个数. 其中按CPU计算方式如下: License Number = The Number of CPU Cores  *  Core  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlXjEb.html" rel="bookmark" class="title">DotNet for Symbian平台</a>
					<div>
						支持:Nokia,Sony,Motorola等手机. 支持:Symbian60 v3 及其以上. 支持:.net CF1,SmartPhone2003类型项目. 支持:vs2003,vs2005 现在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AVnnp.html" rel="bookmark" class="title">与众不同windows phone &lpar;45&rpar; 8&period;0 语音&colon; TTS&comma; 语音识别&comma; 语音命令</a>
					<div>
						介绍 与众不同 windows phone 8.0 之 语音 TTS(Text To Speech) 语音识别 语音命令 示例 1.演示 TTS(Text To Speech)的应用 Speech/T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGj5Llp.html" rel="bookmark" class="title">MathType相似符号与波浪号有什么区别</a>
					<div>
						  MathType相似符号与波浪号的区别. 很多人在编辑相似符号时,会直接点击MathType工具栏模板中的&quot;关系符号&quot;模板,选择里面的波浪号,但是在使用这个符号的时候一定要注意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7en5b.html" rel="bookmark" class="title">修改SQL数据库排序规则修改表栏位排序规则</a>
					<div>
						  修改SQL数据库排序规则修改表栏位排序规则 修改SQL数据库排序规则: 1.修改为单用户模式 2.然后关闭所有的查询窗口,修改Options的Collocation属性,如:Chinese_PRC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PGWDM.html" rel="bookmark" class="title">linux下使用ssh管理VPS的注意事项小结</a>
					<div>
						  笔者采用key文件交互登录的方式连接ssh.因此,第一步要生成ssh的key文件. 1.ssh-keygen 2.接着,将服务器上的密钥.公钥下载下来.保存在当前用户的.ssh文件夹下. 这里需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badBQgz.html" rel="bookmark" class="title">Word2010中纵横混排技巧简析</a>
					<div>
						  纵横混排,是大家在Word中比较少用的排版技巧,不过却又是十分的实用.虽然Word中本身有自带纵横混排的功能,但是用户较多是用文本框来实现的. 纵横混排 步骤/方法: 打开你的的word,然后点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaJ3Az.html" rel="bookmark" class="title">javascript日期格式化示例</a>
					<div>
						 这篇文章主要介绍了javascript日期格式化示例,需要的朋友可以参考下  代码如下: /**    * 格式化日期    * @param {Object} ms 表示指定日期与 1970 年  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg31nBM.html" rel="bookmark" class="title">js代码实现随机颜色的小方块&lowbar;基础知识</a>
					<div>
						下面一段代码就是用js实现的随机颜色的小方块,不多说了代码很简单,直接上代码了. /**/js注释已删 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NV9NM.html" rel="bookmark" class="title">403 ccess enied- 403Access Denied？？怎么改</a>
					<div>
						问题描述 403Access Denied??怎么改 我在myeclipse做了一个网站,然后输入http://127.0.0.1:8080/manager/login.jsp. 出现错误如下: Yo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxGl5b.html" rel="bookmark" class="title">Ubuntu开机黑屏或花屏解决办法</a>
					<div>
						Ubuntu开机黑屏或花屏解决办法: 开机进入安全模式或叫恢复模式(双系统开机进入第2项(单系统开机时按shift键)-选择root或drop to root shell promot-点击ok) # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVNG8b.html" rel="bookmark" class="title">c&num;-关于C&num;制作的电影管理系统选座后的订票条件设置</a>
					<div>
						问题描述 关于C#制作的电影管理系统选座后的订票条件设置 座位表已经设计出来了,每个座位代表一个数字,一共1-30 然后每个座位有一个state值.当state为0是座位是空,state为1时,座位是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7OoAz.html" rel="bookmark" class="title">Google到底有多强大</a>
					<div>
						国外科技博客Pingdom近日撰文,再次以Google为主题,试图分析其规模和用户数量,以下是全文. 有很多关于Facebook已经多大规模的讨论,它拥有6亿用户.确实已经成为一股不可忽视的力量.然而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXXDxz.html" rel="bookmark" class="title">nfc技术-NFC和红外遥感性能对比</a>
					<div>
						问题描述 NFC和红外遥感性能对比 NFC与红外遥感哪个技术性更强,哪个支持更多技术应用,适用范围广 解决方案 红外线和NFC的适用场合不同,主要是通讯距离.数据量.协议的区别. 红外比较适合类似遥控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRrqjb.html" rel="bookmark" class="title">推荐几本网络营销方面的书籍</a>
					<div>
						最近接到出版社出书约稿的邀请,结合有关社会化媒体营销方面的书籍出版问题谈谈我对图书出版营销的认识. 随着中国的文化体制的改革,图书出版权利的下放.现在写书,出书,已显得比较平常.我一直认为:没有被充分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwqqZM.html" rel="bookmark" class="title">GMGC2017：一个游戏的大会上 除游戏外我们还能谈什么</a>
					<div>
						一个连手机游戏都不玩的人竟然去参加了一场游戏大会. 上周五,第六届全球游戏大会(GMGC北京2017)在北京国家会议中心闭幕.大会涵盖了游戏.未来科技.直播.电竞.IP联动.VR等多个领域的内容.本来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnGovp.html" rel="bookmark" class="title">Android PopupWindow实现右侧、左侧和底部弹出菜单&lowbar;Android</a>
					<div>
						本教程为大家分享了Android PopupWindow弹出菜单的具体代码,供大家参考,具体内容如下 项目代码:http://xiazai.jb51.net/201611/yuanma/PopupLe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Gw8op.html" rel="bookmark" class="title">jcarousellite&period;js 基于Jquery的图片无缝滚动插件&lowbar;jquery</a>
					<div>
						1.引入JS库,jquery.js脚本和插件脚本jcarousellite.js. 复制代码 代码如下: &lt;script type=&quot;text/javascript&quot; src ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVX0lz.html" rel="bookmark" class="title">Android开发笔记 改变字体颜色的三种方法&lowbar;Android</a>
					<div>
						1.在layout文件下的配置xml文件中直接设置字体颜色,通过添加android:textcolor=&quot;#FFFFFF&quot;来变化颜色 但这样的效果只能让字体千篇一律的显示一种颜色  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWJNap.html" rel="bookmark" class="title">辩解权衡DCIM的成本</a>
					<div>
						在本系列文章的第一部分中,我们就企业部署DCIM会涉及到的相关承诺.挑战.及相关企业内部的政治性问题进行了概述.而在第二部分中,我们为大家介绍了企业在选择一款DCIM解决方案之前,需要重点考虑的相关因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjo5wmM.html" rel="bookmark" class="title">小米电视换了一种思路</a>
					<div>
						摘要: 小米联合创始人 小米电视负责人王川 导语:推出一款电视产品需要多久?传统企业只要三个月,而小米至少花了一年的时间.这还只计算了硬件设计与生产的部分,如果算上软件层面 小米联合创始人 小米电视负 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqg5Nkz.html" rel="bookmark" class="title">继续支持开源，IBM新型主机平台能够更好支持Spark</a>
					<div>
						IBM公司近日宣布推出基于Apache Spark的新型z/OS平台,以帮助企业使用IBM大型主机更加方便.快捷地访问和分析数据.此举将给数据科学家和开发人员创造新的机会,帮助他们对系统丰富的数据集进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWQrWp.html" rel="bookmark" class="title">《CCNP ROUTE 300-101认证考试指南》&mdash;&mdash;2&period;1节&OpenCurlyDoubleQuote;我已经知道了吗？&rdquo;测试题</a>
					<div>
						2.1 &quot;我已经知道了吗?&quot;测试题CCNP ROUTE 300-101认证考试指南通过完成&quot;我已经知道了吗?&quot;测试题,能够帮助你对本章主题的掌握情况进行自我评估 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKa7Ez.html" rel="bookmark" class="title">专访张伟钦&colon;趋势科技云计算安全5&period;0解读</a>
					<div>
						本文讲的是专访张伟钦:趋势科技云计算安全5.0解读,9月2日消息,日前,趋势科技在京发布了其云计算安全5.0解决方案,趋势科技全球研发长暨大中华区执行副总裁张伟钦接受了媒体的采访,并就趋势科技云计算安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBx5Ab.html" rel="bookmark" class="title">Red Hat 红帽企业Linux 5 SERVER 正式版 迅雷下载地址&lowbar;常用工具</a>
					<div>
						发行注记:http://www.redhat.com/docs/manua ... 5-manual/index.html 建议大家用迅雷下ftp://60.232.126.152/os/linux/ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.049 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
